# Team 3 Full-Stack App | Casino
### By Carlos Galvan Jr, David Garcia, Fuming Zhao

Our full-stack application connects a back-end which maintains persisted data in an AWS database
with a front-end that delivers a User Interface to the client. Both ends serve to deliver an experience
which our group has determined to be a "casino" style website. 

Our users can create an account, and, contingent on the existence of the email provided, receive an email regarding their
account creation status. They can choose between three games: Rock Paper Scissors, Stock Price Guessing, and Coin
Flip. When a user makes an account, they are given a point balance of 1000. With this balance, they are free to make bets
on any of the three games, and their objective is to take that balance as far as they can and make it to the top of the
leaderboard.

## Back-end Gitlab Repository Link
> https://gitlab.com/210614-java-react-enterprise/project-2/team-3-project2-public

## User stories
> We narrowed down our user stories early by having a rough idea of what our website user experience was going to be.
> Below are the user stories we were able to identify as important for our MVP:
> * I can create an account
> * I can log in to my account
> * I can play Rock Paper Scissors
> * I can play Stock Price Guessing
> * I can play Coin Flip
> * I can recieve email verification that my account was created
> * I can look at my account's history
> * I can log out of my account
> * I can look at the global leaderboard
> * I can make bets on each game I play

## AWS S3
> Our frontend is fully-deployed on an AWS S3 bucket, modified for static web-page hosting. Please visit the link and see for
> yourself! \
> \
> http://project-2-bucket.s3-website.us-east-2.amazonaws.com/


## External APIs Leveraged
> Our initial project idea heavily relied on use finding APIs that we felt confident we could work with. Thus, our choice
> to use the two APIs below was a large factor in helping us design the idea of our MVP! Below are the two external APIs we leveraged:
> 1) Yahoofinance API - Used to scrape data from Yahoo Finance and returns up to date stock information for our Stock Guessing Game.
> 2) Java Mail API - Used to send an "account created" email to the user, which serves as an external validation that their
    account data has persisted to our database.

## Testing Statistics
> Below is a compilation of our latest testing statistics, as generated by Jacoco:
> * **Service Layer:** 91% coverage
> * **Controller Layer:** 92% coverage

Our application is developed from front-end to back-end by scratch. Below we have listed the technologies we used and how
they are implemented specifically in our application.
## Hibernate
>  The Hibernate ORM maps our database information into Spring Beans, which we then use throughout our back-end to serve
>  information to the front-end. See some examples pulled from our package path: `dev.team3.daos`
> ```java
> StockSymbol findOneById(int id);
> List<Account> findByEmail(String email);
> List<Account> findByUsername(String userName);
> ```

## Spring
> Our entire backend relies and was built using spring as the backbone.
> * **Spring Core:** We created classes which serve as beans mapped by our RDBMS.
> * **Spring MVC:** We created our `@Controller` designated beans, which maps our http requests to their respective paths
> * **Spring AOP:** When launched, our spring container has a logging aspect which serves to provide console outputted information
>                       on methods being invoked.
> * **Spring Boot:** Running our Spring Boot application was as simple as creating a driver class with the `@SpringBootApplication`
>                       annotation, and creating a main method which contained `SpringApplication.run(Driver.class,args);`

## AWS EC2 with Docker and Jenkins
> Our backend is hosted 24/7 on a remote Amazon Linux Machine (AKA: EC2). We leveraged Jenkins to build and deploy our docker
> containers based off of our gitlab repository. Our Jenkins is set up to automatically build based off of gitlab push events!
> This setup allowed our team to integrate continuous integration and continuous deployment elements to our project.

## Our Stretch Goal User Stories
> We had extra user stories that we would have liked to include in our project, but due to time constraints, we left them out.
> However, they are documented below in case the project is picked up again in the future. Hopefully, the stories listed below
> can serve as a guide for the direction we hoped our full-stack application could go.
> * I can receive emails regarding my game history
> * I can play chess against an AI
> * I can play checkers against an AI
> * I can play chess against a person
> * I can play checkers against a person
> * I can bet on a chess or checkers match